"use strict";

// Теоритичні питання:
// 1. В чому полягає відмінність localStorage і sessionStorage?
// Тривалість зберігання даних:

// localStorage: дані зберігаються безстроково або доки користувач не видалить їх явно або не очистить кеш браузера.
// sessionStorage: дані зберігаються тільки протягом поточної сесії браузера. Як тільки користувач закриє вкладку або вікно браузера, дані sessionStorage будуть видалені.

// 2. Які аспекти безпеки слід враховувати при збереженні чутливої інформації, такої як паролі, за допомогою localStorage чи sessionStorage?
// Ніколи не треба зберігати паролі в чистому вигляді: Паролі слід завжди хешувати перед збереженням. Хешування паролю перетворює його на неповторний рядок, який не може бути легко перетворений назад у вихідний пароль. Це дозволяє зберігати паролі безпечно навіть в localStorage чи sessionStorage.

// Треба використовувати безпечне зберігання: Якщо потрібно зберігати паролі, краще використовувати sessionStorage, оскільки дані, збережені в ньому, автоматично видаляються при закритті вкладки браузера або вікна. Якщо потрібно зберігати дані на довший термін, можна розглянути використання кукісів з встановленням атрибутів httpOnly та secure.

// Треба уникати використання обробників подій для відстеження паролів: Під час введення пароля користувачем треба уникати відправлення його через обробники подій, які можуть бути перехоплені. Замість цього треба використовувати безпосередньо значення поля введення.

// Захист від XSS-атак: Треба бути впевниним, що програма не вразлива на атаки Cross-Site Scripting (XSS). Треба заборонити вставку скриптів безпосередньо в localStorage або sessionStorage.

// Треба використовувати HTTPS: Забезпечте, щоб ваш сайт використовував HTTPS, щоб дані, які ви передаєте між клієнтом і сервером, були зашифровані.

// Не можна передавати паролі через URL: Не треба включати паролі до URL-адреси сторінки, оскільки це може зробити їх доступними для перехоплення.

// Треба використовувати бібліотеки аутентифікації: розроблені та перевірені бібліотеки аутентифікації для обробки паролів та інших чутливих даних.

// 3. Що відбувається з даними, збереженими в sessionStorage, коли завершується сеанс браузера?
//Коли сеанс браузера завершується (наприклад, коли користувач закриває вкладку або виходить зі свого облікового запису), дані, збережені в sessionStorage, автоматично видаляються. Це означає, що дані, збережені в sessionStorage, існують лише протягом одного сеансу браузера і не залишаються після закриття вкладки або вікна браузера.

// Ось декілька ключових моментів, пов'язаних з поведінкою sessionStorage:

// Обмежений час існування: Дані, збережені в sessionStorage, існують лише під час життєвого циклу сеансу браузера. Як тільки користувач закриває вкладку або виходить зі сеансу, дані видаляються.

// Локальне для кожної вкладки: Кожна вкладка браузера має свій власний sessionStorage, тому дані, збережені в одній вкладці, не доступні в інших вкладках.

// Не пересилаються на сервер: Дані, збережені в sessionStorage, не пересилаються на сервер. Вони лише зберігаються локально на браузері клієнта.

// Видаляються після закриття сеансу браузера: Як тільки користувач завершує сеанс браузера, усі дані, збережені в sessionStorage, видаляються автоматично.

// Практичне завдання:

// Реалізувати можливість зміни колірної теми користувача.

// Технічні вимоги:

// - Взяти готове домашнє завдання HW-4 "Price cards" з блоку Basic HMTL/CSS.
// - Додати на макеті кнопку "Змінити тему".
// - При натисканні на кнопку - змінювати колірну гаму сайту (кольори кнопок, фону тощо) на ваш розсуд. При повторному натискання - повертати все як було спочатку - начебто для сторінки доступні дві колірні теми.
// - Вибрана тема повинна зберігатися після перезавантаження сторінки.

// Примітки:
// - при виконанні завдання перебирати та задавати стилі всім елементам за допомогою js буде вважатись помилкою;
// - зміна інших стилів сторінки, окрім кольорів буде вважатись помилкою.

// Додаткові матеріали: https://developer.mozilla.org/en-US/docs/Web/CSS/Using_CSS_custom_properties.

const themeToggle = document.getElementById("btn-theme-toggle");
const themeSwitch = document.getElementById("light-theme");

function toggleTheme() {
  if (themeSwitch.getAttribute("class") === "light-theme") {
    themeSwitch.setAttribute("class", "dark-theme");
    localStorage.setItem("theme", "dark");
  } else {
    themeSwitch.setAttribute("class", "light-theme");
    localStorage.setItem("theme", "light");
  }
}
themeToggle.addEventListener("click", toggleTheme);
document.addEventListener("DOMContentLoaded", function () {
  const savedTheme = localStorage.getItem("theme");
  if (savedTheme === "dark") {
    themeSwitch.setAttribute("class", "dark-theme");
  } else {
    themeSwitch.setAttribute("class", "light-theme");
  }
});
